import 'package:testik_generator/src/template/params.dart';

import 'comma_list.dart';

class TestikTemplate {

 final String className;
 ParamListTemplate<GetterParamTemplate> params;

  TestikTemplate(this.className, List<ParamTemplate> args) {
    var testikClassParams = <GetterParamTemplate>[];
    for(int i=0; i<args.length; i++) {
      var param = args[i];
      testikClassParams.add(GetterParamTemplate(param)); 
    }
    params = ParamListTemplate<GetterParamTemplate>(testikClassParams);
  }

  @override
  String toString() => """
  // ignore_for_file: non_constant_identifier_names, unnecessary_lambdas, prefer_expression_function_bodies, lines_longer_than_80_chars
  
  abstract class _\$$className {
   _\$$className._();
    $params  
  }""";

}

class TestikInitTemplate {

 final String className;


 CommaList<ParamThisTemplate> constructorParams;
 ParamListTemplate<OverrideParamTemplate> params;

  TestikInitTemplate(this.className, List<ParamTemplate> args) {
    var testikClassParams = <OverrideParamTemplate>[];
    var testikConstructorParams = <ParamThisTemplate>[];

    for(int i=0; i<args.length; i++) {
      var param = args[i];
      testikClassParams.add(OverrideParamTemplate(param)); 
      testikConstructorParams.add(ParamThisTemplate(param.name));
    }

    params = ParamListTemplate<OverrideParamTemplate>(testikClassParams);
    constructorParams = CommaList<ParamThisTemplate>(testikConstructorParams);  
  }

  @override
  String toString() => """

  abstract class _\$${className}\$ extends ${className} {
   _\$${className}\$._($constructorParams) : super._();
   $params
  }""";

}